// Generated by CoffeeScript 1.10.0
(function() {
  var app, assert, async, express, expressResponseError, i18n, supertest, test;

  expressResponseError = require('../index');

  express = require('express');

  async = require('async');

  assert = require('assert');

  i18n = require('i18n');

  i18n.configure({
    locales: ['en'],
    directory: __dirname + '/locales'
  });

  supertest = require('supertest');

  app = new express();

  app.use(i18n.init);

  app.get('*', expressResponseError({
    translate: 'i18n'
  }), function(req, res) {
    return res.error(req.query.message || 'no message', req.query.statusCode);
  });

  app.use(function(err, req, res, next) {
    return res.status(err.code).send({
      error: err.message
    });
  });

  test = supertest(app);

  describe('middleware', function() {
    it('should return status code', function(done) {
      return async.forEach([200, 201, 400], function(status, cb) {
        return test.get('/?message=status-' + status + '&statusCode=' + status).expect(status).expect(function(res) {
          return assert.equal(res.body.error, 'status-' + status);
        }).end(cb);
      }, done);
    });
    return it('should return test response', function(done) {
      return async.forEach([200, 201, 400], function(status, cb) {
        return test.get('/?message=TEST_RESPONSE&statusCode=' + status).expect(status).expect(function(res) {
          return assert.equal(res.body.error, 'this is test response');
        }).end(cb);
      }, done);
    });
  });

}).call(this);
